$regfile = "m168def.dat"
$crystal = 8000000
$hwstack = 40
$swstack = 16
$framesize = 32

Dim Pusk As Byte , X As Byte , X1 As Byte , Pribor As Byte , Angle As Byte , K As Byte
Dim T1 As Word , N As Word , N1 As Word , N2 As Word , T3 As Word , Calc As Single , Calc1 As Single
Dim T2 As Byte , Zad As Byte
Dim M1 As String * 1 , M As String * 4

Config Portb = Output                                       '
Config Portd.2 = Input                                      'int0
Config Portd.7 = Output

Config Portc.0 = Output
Reset Portc.0
Config Portc.1 = Output
Reset Portc.1
Config Portc.2 = Output
Reset Portc.2
Config Portc.3 = Output
Reset Portc.3

Config Portd.0 = Input
Config Portc.4 = Input
Config Portc.5 = Input

Config Portd.4 = Input

Led Alias Portd.7
Reset Led

Red Alias Pind.0
Blue Alias Pinc.4

Config Timer1 = Timer , Prescale = 256
Stop Timer1
Timer1 = 0

Config Timer2 = Timer , Prescale = 1024
Ocr2a = 7                                                   '128     - 0.9 
Ocr2b = 78                                                  '10    INT
Stop Timer2
Timer2 = 0

Config Int0 = Falling
Config Int1 = Falling

On Int0 Cilinder
On Int1 Uoz
On Oc2a Ledoff
On Oc2b Inton
On Oc1a Ledon
On Oc1b End6

Enable Interrupts
Enable Oc2a
Enable Oc2b

Pusk = 0 : Pribor = 0




50:
If Pinc.5 = 0 Then Goto 200                                 '


If Pribor = 10 Then Goto 100

Disable Int1                                                '
Disable Oc1a
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Timer1 = 0
Ocr1b = 46875                                               '6 sec

Enable Int0
Enable Oc1b
If Pind.4 = 1 Then K = 20 Else K = 10                       '20-1    10 - 2   
N = 0 : M = "1234"
Pribor = 10
Start Timer1

100:                                                        '

M1 = Mid(m , 1 , 1)                                         '
Gosub Digit
Set Portc.3
Waitms 5
M1 = Mid(m , 2 , 1)
Gosub Digit
Reset Portc.3
Set Portc.2
Waitms 5
M1 = Mid(m , 3 , 1)
Gosub Digit
Reset Portc.2
Set Portc.1
Waitms 5
M1 = Mid(m , 4 , 1)
Gosub Digit
Reset Portc.1
Set Portc.0
Waitms 5
Reset Portc.0
Goto 50






200:                                                        '

If Pribor = 20 Then Goto 250

Disable Int0
Disable Oc1b

Config Timer1 = Timer , Prescale = 8                        '
Stop Timer1
Ocr1a = 1
Stop Timer2
Timer2 = 0

Calc1 = 60 / N
Calc1 = Calc1 * 1000000
Calc = Calc1 / 360                                          '  1 
T1 = Round(calc)                                            '  
Zad = N / 8                                                 ' 
Angle = 0
M = " -0G"
T3 = 0
Enable Int1
Enable Oc1a
Pribor = 20

250:

M1 = Mid(m , 1 , 1)
Gosub Digit
Set Portc.3
Waitms 4
M1 = Mid(m , 2 , 1)
Gosub Digit
Reset Portc.3
Set Portc.2
Waitms 4
M1 = Mid(m , 3 , 1)
Gosub Digit
Reset Portc.2
Set Portc.1
Waitms 4
M1 = Mid(m , 4 , 1)
Gosub Digit
Reset Portc.1
Set Portc.0
Waitms 4
Reset Portc.0
Goto 50







Cilinder:                                                   '1 

Disable Int0

Set Led
Start Timer2
Incr T1

Endcil:
Return



End6:

N = T1 * K
M = Str(n)
If N < 1000 Then M = " " + M
T1 = 0
Timer1 = 0

Return










Uoz:

Disable Int1
Start Timer1
Return



Ledon:

Set Led
Start Timer2
Stop Timer1
Timer1 = 0
Return



Ledoff:

Reset Led

If T3 > 0 Then
Decr T3
Goto End1
End If

If Red = 0 Then                                             '
If Angle > 24 Then Goto End1
Ocr1a = Ocr1a + T1
Incr Angle
M = "-" + Str(angle) + "G"
If Angle < 10 Then M = " " + M
T3 = Zad
Goto End1
End If

If Blue = 0 Then
If Angle = 0 Then Goto End1                                 ' 
Ocr1a = Ocr1a - T1
Decr Angle
M = "-" + Str(angle) + "G"
If Angle < 10 Then M = " " + M
T3 = Zad
Goto End1
End If

End1:
Return


Inton:

Stop Timer2
Timer2 = 0
Eifr = 3
If Pribor = 10 Then Enable Int0 Else Enable Int1
Return


Digit:

Select Case M1
Case "0" : Portb = &B01101111
Case "1" : Portb = &B00101000
Case "2" : Portb = &B01110011
Case "3" : Portb = &B00111011
Case "4" : Portb = &B00111100
Case "5" : Portb = &B00011111
Case "6" : Portb = &B01011111
Case "7" : Portb = &B00101101
Case "8" : Portb = &B01111111
Case "9" : Portb = &B00111111
Case "-" : Portb = &B00010000
Case "G" : Portb = &B00110101
Case "E" : Portb = &B01010111
Case "R" : Portb = &B01010000
Case " " : Portb = &B00000000
End Select
Return


End